## element-0.46.6-2.src.tar.gz

=== wscript ===
#!/usr/bin/env python

from subprocess import call, Popen, PIPE
from waflib import Utils
import os, sys
import string
sys.path.insert (0, os.path.join (os.getcwd(), 'tools/waf'))
import cross, element, juce, git

APPNAME         = element.APPNAME
VERSION         = element.VERSION
PLUGIN_VERSION  = element.PLUGIN_VERSION

VST3_PATH = 'libs/JUCE/modules/juce_audio_processors/format_types/VST3_SDK'

def options (opt):
    opt.load ("scripting compiler_c compiler_cxx ccache cross juce")

    opt.add_option ('--disable-ladspa', default=False, action='store_true', dest='no_ladspa', \
        help="Disable LADSPA plugin hosting")
    opt.add_option ('--disable-lv2', default=False, action='store_true', dest='no_lv2', \
        help="Disable LV2 plugin hosting")
    opt.add_option ('--with-vstsdk24', default='', dest='vstsdk24', type='string', 
        help='Path to vstsdk2.4 sources')
    opt.add_option ('--disable-vst', default=False, action='store_true', dest='no_vst', \
        help="Disable VST2 plugin hosting")
    opt.add_option ('--disable-vst3', default=False, action='store_true', dest='no_vst3', \
        help="Disable VST3 plugin hosting")
    
    opt.add_option ('--enable-docking', default=False, action='store_true', dest='enable_docking', \
        help="Build with docking window support")
    
    opt.add_option ('--without-alsa', default=False, action='store_true', dest='no_alsa', \
        help="Build without ALSA support")
    opt.add_option ('--without-jack', default=False, action='store_true', dest='no_jack', \
        help="Build without JACK support")
    
    opt.add_option ('--test', default=False, action='store_true', dest='test', \
        help="Build the test suite")
    opt.add_option ('--ziptype', default='gz', dest='ziptype', type='string', 
        help='Zip type for waf dist (gz/bz2/zip) [ Default: gz ]')

    opt.add_option ('--minimal', dest='minimal', default=False, action='store_true')

def silence_warnings (conf):
    '''TODO: resolve these'''
    conf.env.append_unique ('CFLAGS', ['-Wno-deprecated-declarations'])
    conf.env.append_unique ('CXXFLAGS', ['-Wno-deprecated-declarations'])
    
    if 'clang' in conf.env.CXX[0]:
        conf.env.append_unique ('CFLAGS', ['-Wno-deprecated-register'])
        conf.env.append_unique ('CXXFLAGS', ['-Wno-deprecated-register'])
        conf.env.append_unique ('CFLAGS', ['-Wno-dynamic-class-memaccess'])
        conf.env.append_unique ('CXXFLAGS', ['-Wno-dynamic-class-memaccess'])

def configure (conf):
    conf.env.DATADIR = os.path.join (conf.env.PREFIX,  'share/element')
    conf.env.DOCDIR  = os.path.join (conf.env.PREFIX,  'share/doc/element')
    conf.env.LIBDIR  = os.path.join (conf.env.PREFIX,  'lib')
    conf.env.VSTDIR  = os.path.join (conf.env.LIBDIR,  'vst')
    conf.env.VST3DIR = os.path.join (conf.env.LIBDIR,  'vst3')
    
    conf.load ('bundle')
    conf.load ('templates')
    conf.prefer_clang()
    conf.load ("compiler_c compiler_cxx")
    conf.check_cxx_version()
    conf.load ('ccache')
    conf.load ("git")
    conf.load ("juce")
    conf.load ('scripting')

    silence_warnings (conf)

    conf.find_projucer (mandatory=False)
    conf.find_program ('convert', mandatory=False)
    
    conf.check_common()
    if cross.is_mingw (conf): conf.check_mingw()
    elif juce.is_mac(): conf.check_mac()
    else: conf.check_linux()

    conf.env.TEST = bool(conf.options.test)
    conf.env.DEBUG = conf.options.debug
    
    conf.define ('EL_DOCKING', True if conf.options.enable_docking else False)
    conf.define ('KV_DOCKING_WINDOWS', 1)
    if len(conf.env.GIT_HASH) > 0:
        conf.define ('EL_GIT_VERSION', conf.env.GIT_HASH)

    # Hidden Visibiility by default
    for k in 'CFLAGS CXXFLAGS'.split():
        conf.env.append_unique (k, ['-fvisibility=hidden'])

    print
    juce.display_header ("Element")
    conf.message ("Config", 'Debug' if conf.options.debug else 'Release')
    conf.message ("Workspaces", conf.options.enable_docking)
    conf.message ("Scripting",  bool(conf.env.LUA))
    conf.message ("Workspaces", conf.options.enable_docking)
    print
    juce.display_header ("Audio Devices")
    conf.message ("Alsa",       conf.env.ALSA)
    conf.message ("JACK Audio", conf.env.JACK)
    print
    juce.display_header ("Plugin Host")
    conf.message ("AudioUnit",  juce.is_mac())
    conf.message ("VST2",       conf.env.VST)
    conf.message ("VST3",       conf.env.VST3)
    conf.message ("LADSPA",     bool(conf.env.LADSPA))
    conf.message ("LV2",        bool(conf.env.LV2))
    print
    juce.display_header ("Plugin Clients")
    conf.message ("VST2",       conf.env.VST)
    print
    juce.display_header ("Paths")
    conf.message ("Prefix",      conf.env.PREFIX)
    conf.message ("Data",        conf.env.DATADIR)
    conf.message ("Modules",     conf.env.LUADIR)
    conf.message ("Scripts",     conf.env.SCRIPTSDIR)
    if conf.env.VST:
        conf.message ("VST",     conf.env.VSTDIR)
    print
    juce.display_header ("Compiler")
    conf.display_archs()
    conf.message ("CC",             ' '.join (conf.env.CC))
    conf.message ("CXX",            ' '.join (conf.env.CXX))
    conf.message ("CFLAGS",         conf.env.CFLAGS)
    conf.message ("CXXFLAGS",       conf.env.CXXFLAGS)
    conf.message ("LINKFLAGS",      conf.env.LINKFLAGS)

def common_includes():
    return [
        VST3_PATH, \
        'libs/JUCE/modules', \
        'libs/kv/modules', \
        'libs/jlv2/modules', \
        'libs/compat', \
        'libs/element/lua', \
        'build/include', \
        'src'
    ]

def lua_kv_sources (ctx):
    return ctx.path.ant_glob ('libs/lua-kv/src/kv/**/*.c') + \
           ctx.path.ant_glob ('libs/lua-kv/src/kv/**/*.cpp')

def juce_sources (ctx):
    return element.get_juce_library_code ("libs/compat") + \
           ctx.path.ant_glob ('libs/compat/BinaryData*.cpp')

def common_sources (ctx):
    return juce_sources (ctx) + lua_kv_sources (ctx) + \
            ctx.path.ant_glob ('src/**/*.cpp')

def build_desktop (bld, slug='element'):
    if not juce.is_linux():
        return

    if bool(bld.env.CONVERT):
        for size in '16 32 64 128 256 512'.split():
            geometry = '%sx%s' % (size, size)
            bld (
                rule   = '%s ${SRC} -resize %s ${TGT}' % (bld.env.CONVERT[0], geometry),
                source = 'data/ElementIcon.png',
                target = 'share/icons/hicolor/%s/apps/net.kushview.element.png' % geometry,
                install_path = bld.env.PREFIX + '/share/icons/hicolor/%s/apps' % geometry
            )
    else:
        bld (
            rule = 'cp -f ${SRC} ${TGT}',
            source = 'data/ElementIcon_512x512.png',
            target = 'share/icons/hicolor/512x512/apps/net.kushview.element.png',
            install_path = bld.env.PREFIX + '/share/icons/hicolor/512x512/apps'
        )

    src = "data/net.kushview.%s.desktop.in" % (slug)
    tgt = "share/applications/net.kushview.%s.desktop" % (slug)

    if os.path.exists (src):
        bld (features = "subst",
             source         = src,
             target         = tgt,
             name           = tgt,
             ELEMENT_EXE    = 'element',
             ELEMENT_ICON   = 'net.kushview.element',
             install_path   = bld.env.PREFIX + "/share/applications"
        )

    bld.install_files (bld.env.DATADIR, 'data/ElementIcon.png')

def build_lua_docs (bld):
    if bool(bld.env.LDOC):
        call ([bld.env.LDOC[0], '-f', 'markdown', '.' ])

def build_lua_lib (bld):
    luaEnv = bld.env.derive()
    for k in 'CFLAGS CXXFLAGS LINKFLAGS'.split():
        luaEnv.append_unique (k, [ '-fPIC' ])
    lua = bld (
        name     = 'LUA',
        target   = 'lib/lua',
        env      = luaEnv,
        install_path = None,
        features = 'cxx cxxstlib',
        includes = [
            'libs/lua',
            'libs/lua/src',
            'libs/lua-kv/include',
            'libs/lua-kv/src',
        ],
        source = '''
            libs/lua/src/lauxlib.c
            libs/lua/src/liolib.c
            libs/lua/src/lopcodes.c
            libs/lua/src/lstate.c
            libs/lua/src/lobject.c
            libs/lua/src/lmathlib.c
            libs/lua/src/loadlib.c
            libs/lua/src/lvm.c
            libs/lua/src/lfunc.c
            libs/lua/src/lstrlib.c
            libs/lua/src/linit.c
            libs/lua/src/lstring.c
            libs/lua/src/lundump.c
            libs/lua/src/lctype.c
            libs/lua/src/ltable.c
            libs/lua/src/ldump.c
            libs/lua/src/loslib.c
            libs/lua/src/lgc.c
            libs/lua/src/lzio.c
            libs/lua/src/ldblib.c
            libs/lua/src/lutf8lib.c
            libs/lua/src/lmem.c
            libs/lua/src/lcorolib.c
            libs/lua/src/lcode.c
            libs/lua/src/ltablib.c
            libs/lua/src/lapi.c
            libs/lua/src/lbaselib.c
            libs/lua/src/ldebug.c
            libs/lua/src/lparser.c
            libs/lua/src/llex.c
            libs/lua/src/ltm.c
            libs/lua/src/ldo.c
        '''.split()
    )
    lua.export_includes = lua.includes
    return lua

def add_scripts_to (bld, builddir, instdir, 
                    modsdir='Modules', 
                    scriptsdir='Scripts'):
    for node in bld.path.ant_glob ('libs/element/lua/el/*.lua'):
        s = bld (
            features    ='subst', 
            source      = node,
            target      = '%s/%s/el/%s' % (builddir, modsdir, node.name),
            install_path= '%s/%s/el' % (instdir, modsdir) if instdir else None
        )
    for node in bld.path.ant_glob ('libs/lua-kv/src/kv/*.lua'):
        bld (
            features    ='subst',
            source      = node,
            target      = '%s/%s/kv/%s' % (builddir, modsdir, node.name),
            install_path= '%s/%s/kv' % (instdir, modsdir) if instdir else None
        )
    for node in bld.path.ant_glob ('scripts/**/*.lua'):
        bld (
            features    ='subst',
            source      = node,
            target      = '%s/%s/%s' % (builddir, scriptsdir, node.name),
            install_path= '%s/%s' % (instdir, scriptsdir) if instdir else None
        )

def build_vst_linux (bld, plugin):
    vstEnv = bld.env.derive()
    for k in 'CFLAGS CXXFLAGS LINKFLAGS'.split():
        vstEnv.append_unique (k, [ '-fPIC' ])
    vstEnv.cxxshlib_PATTERN = bld.env.plugin_PATTERN
    vst = bld (
        features        = 'cxx cxxshlib',
        source          = [
            'tools/jucer/%s/Source/%s.cpp' % (plugin, plugin),
            'libs/compat/include_juce_audio_plugin_client_VST2.cpp'
        ],
        includes        = common_includes(),
        target          = 'plugins/VST/%s' % plugin,
        name            = 'ELEMENT_VST',
        env             = vstEnv,
        use             = [ 'ELEMENT', 'LUA' ],
        install_path    = '%s/Kushview' % bld.env.VSTDIR,
    )

def build_vst (bld):
    if not bld.env.VST:
        return
    if juce.is_linux():
        for plugin in 'Element ElementFX'.split():
            build_vst_linux (bld, plugin)

def vst3_bundle_arch():
    if juce.is_mac():
        return 'MacOS'
    if juce.is_linux():
        return 'x86_64-linux'
    return ''

def build_vst3_linux (bld, plugin):
    if not bld.env.VST:
        return

    vstEnv = bld.env.derive()
    for k in 'CFLAGS CXXFLAGS LINKFLAGS'.split():
        vstEnv.append_unique (k, [ '-fPIC' ])
    
    vstEnv.cxxshlib_PATTERN = bld.env.plugin_PATTERN
    vst3 = bld.bundle (
        name            = '%s_BUNDLE_VST3' % plugin,
        target          = 'plugins/VST3/%s.vst3' % plugin,
        install_path    = '%s/Kushview' % (bld.env.VST3DIR)
    )

    binary = vst3.bundle_create_child ('Contents/%s/%s' % (vst3_bundle_arch(), plugin),
        features        = 'cxx cxxshlib',
        name            = '%s_VST3' % plugin,        
        source          = [
            'tools/jucer/%s/Source/%s.cpp' % (plugin, plugin),

=== docs/requirements.txt ===
sphinx_rtd_theme
myst-parser
sphinxcontrib-luadomain==1.1.2
sphinx-lua==1.1.3

=== libs/JUCE/CMakeLists.txt ===
# ==============================================================================
#
#  This file is part of the JUCE library.
#  Copyright (c) 2020 - Raw Material Software Limited
#
#  JUCE is an open source library subject to commercial or open-source
#  licensing.
#
#  By using JUCE, you agree to the terms of both the JUCE 6 End-User License
#  Agreement and JUCE Privacy Policy (both effective as of the 16th June 2020).
#
#  End User License Agreement: www.juce.com/juce-6-licence
#  Privacy Policy: www.juce.com/juce-privacy-policy
#
#  Or: You may also use this code under the terms of the GPL v3 (see
#  www.gnu.org/licenses).
#
#  JUCE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY, AND ALL WARRANTIES, WHETHER
#  EXPRESSED OR IMPLIED, INCLUDING MERCHANTABILITY AND FITNESS FOR PURPOSE, ARE
#  DISCLAIMED.
#
# ==============================================================================

cmake_minimum_required(VERSION 3.12)

project(JUCE VERSION 6.0.8 LANGUAGES C CXX)

set_property(GLOBAL PROPERTY USE_FOLDERS YES)

set(JUCE_MODULES_DIR "${JUCE_SOURCE_DIR}/modules" CACHE INTERNAL
    "The path to JUCE modules")

include(extras/Build/CMake/JUCEUtils.cmake)

juce_disable_default_flags()

set_directory_properties(PROPERTIES
    JUCE_COMPANY_NAME       "JUCE"
    JUCE_COMPANY_WEBSITE    "juce.com"
    JUCE_COMPANY_EMAIL      "info@juce.com"
    JUCE_COMPANY_COPYRIGHT  "Copyright (c) 2020 - Raw Material Software Limited")

option(JUCE_COPY_PLUGIN_AFTER_BUILD
    "Whether or not plugins should be installed to the system after building" OFF)
set_property(GLOBAL PROPERTY JUCE_COPY_PLUGIN_AFTER_BUILD ${JUCE_COPY_PLUGIN_AFTER_BUILD})

set(CMAKE_CXX_EXTENSIONS FALSE)

# This option controls whether dummy targets are added to the build, where these targets contain all
# of the source files for each JUCE module. If you're planning to use an IDE and want to be able to
# browse all of JUCE's source files, this may be useful. However, it will increase the size of
# generated IDE projects and might slow down configuration a bit. If you enable this, you should
# probably also add `set_property(GLOBAL PROPERTY USE_FOLDERS YES)` to your top level CMakeLists,
# otherwise the module sources will be added directly to the top level of the project, instead of in
# a nice 'Modules' subfolder.

option(JUCE_ENABLE_MODULE_SOURCE_GROUPS "Show all module sources in IDE projects" OFF)

add_subdirectory(modules)
add_subdirectory(extras/Build)

# If you want to build the JUCE examples with VST2/AAX support, you'll need to make the VST2/AAX
# headers visible to the juce_audio_processors module. You can either set the paths on the command
# line, (e.g. -DJUCE_GLOBAL_AAX_SDK_PATH=/path/to/sdk) if you're just building the JUCE examples, or
# you can call the `juce_set_*_sdk_path` functions in your own CMakeLists after importing JUCE.

if(JUCE_GLOBAL_AAX_SDK_PATH)
    juce_set_aax_sdk_path("${JUCE_GLOBAL_AAX_SDK_PATH}")
endif()

if(JUCE_GLOBAL_VST2_SDK_PATH)
    juce_set_vst2_sdk_path("${JUCE_GLOBAL_VST2_SDK_PATH}")
endif()

# We don't build anything other than the juceaide by default, because we want to keep configuration
# speedy and the number of targets low. If you want to add targets for the extra projects and
# example PIPs (there's a lot of them!), specify -DJUCE_BUILD_EXAMPLES=ON and/or
# -DJUCE_BUILD_EXTRAS=ON when initially generating your build tree.

option(JUCE_BUILD_EXTRAS "Add build targets for the Projucer and other tools" OFF)

if(JUCE_BUILD_EXTRAS)
    add_subdirectory(extras)
endif()

option(JUCE_BUILD_EXAMPLES "Add build targets for the DemoRunner and PIPs" OFF)

if(JUCE_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# ==================================================================================================
# Install configuration

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.14")
    set(extra_version_arg ARCH_INDEPENDENT)
endif()

include(CMakePackageConfigHelpers)
write_basic_package_version_file("${JUCE_BINARY_DIR}/JUCEConfigVersion.cmake"
    VERSION ${JUCE_VERSION}
    COMPATIBILITY ExactVersion
    ${extra_version_arg})

set(JUCE_INSTALL_DESTINATION "lib/cmake/JUCE-${JUCE_VERSION}" CACHE STRING
    "The location, relative to the install prefix, where the JUCE config file will be installed")

set(JUCE_MODULE_PATH "include/JUCE-${JUCE_VERSION}/modules")
set(UTILS_INSTALL_DIR "${JUCE_INSTALL_DESTINATION}")
set(JUCEAIDE_PATH "${JUCE_TOOL_INSTALL_DIR}/${JUCE_JUCEAIDE_NAME}")
configure_package_config_file("${JUCE_CMAKE_UTILS_DIR}/JUCEConfig.cmake.in"
    "${JUCE_BINARY_DIR}/JUCEConfig.cmake"
    PATH_VARS UTILS_INSTALL_DIR JUCEAIDE_PATH JUCE_MODULE_PATH
    INSTALL_DESTINATION "${JUCE_INSTALL_DESTINATION}")

set(JUCE_MODULE_PATH "${JUCE_MODULES_DIR}")
set(UTILS_INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/extras/Build/CMake")
get_target_property(JUCEAIDE_PATH juceaide IMPORTED_LOCATION)
configure_package_config_file("${JUCE_CMAKE_UTILS_DIR}/JUCEConfig.cmake.in"
    "${JUCE_BINARY_DIR}/JUCEExportConfig.cmake"
    PATH_VARS UTILS_INSTALL_DIR JUCEAIDE_PATH JUCE_MODULE_PATH
    INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}"
    INSTALL_DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

install(FILES "${JUCE_BINARY_DIR}/JUCEConfigVersion.cmake"
              "${JUCE_BINARY_DIR}/JUCEConfig.cmake"
              "${JUCE_CMAKE_UTILS_DIR}/JUCEHelperTargets.cmake"
              "${JUCE_CMAKE_UTILS_DIR}/JUCECheckAtomic.cmake"
              "${JUCE_CMAKE_UTILS_DIR}/JUCEUtils.cmake"
              "${JUCE_CMAKE_UTILS_DIR}/LaunchScreen.storyboard"
              "${JUCE_CMAKE_UTILS_DIR}/PIPAudioProcessor.cpp.in"
              "${JUCE_CMAKE_UTILS_DIR}/PIPComponent.cpp.in"
              "${JUCE_CMAKE_UTILS_DIR}/PIPConsole.cpp.in"
              "${JUCE_CMAKE_UTILS_DIR}/RecentFilesMenuTemplate.nib"
              "${JUCE_CMAKE_UTILS_DIR}/UnityPluginGUIScript.cs.in"
              "${JUCE_CMAKE_UTILS_DIR}/copyDir.cmake"
              "${JUCE_CMAKE_UTILS_DIR}/juce_runtime_arch_detection.cpp"
        DESTINATION "${JUCE_INSTALL_DESTINATION}")

=== libs/jlv2/wscript ===
#!/usr/bin/evn python
# encoding: utf-8
# Copyright (C) 2019 Michael Fisher <mfisher@kushview.net>

import sys, os, platform
from subprocess import call
from waflib.extras import autowaf as autowaf
from waflib.extras import juce as juce

APPNAME = 'jlv2'
VERSION = '0.1.0'
top = '.'
out = 'build'

def options (opts):
    autowaf.set_options (opts)
    opts.load ('compiler_c compiler_cxx autowaf juce')

def silence_warnings (conf):
    # TODO: update LV2 module to use latest LV2 / LILV / SUIL
    conf.env.append_unique ('CXXFLAGS', ['-Wno-deprecated-declarations'])

def configure (conf):
    conf.load ('compiler_c compiler_cxx autowaf')
    silence_warnings (conf)

    conf.env.DEBUG = conf.options.debug

    # Write out the version header
    conf.define ("JLV2_VERSION_STRING", VERSION)
    conf.write_config_header ('jlv2/version.h', 'JLV2_VERSION_H')
    
    for jmod in [ 'juce_audio_processors', 'juce_data_structures', 
                  'juce_audio_devices', 'juce_audio_utils',
                  'juce_gui_extra' ]:
        pkgname = '%s_debug-5' % jmod if conf.options.debug else '%s-5' % jmod
        conf.check_cfg (package=pkgname, uselib_store=jmod.upper(),
                        args=['%s >= 5.4.5' % pkgname, '--libs', '--cflags'], mandatory=True)

    conf.check_cfg (package='lv2', uselib_store='LV2',
                    args=['--libs', '--cflags'], mandatory=True)
    conf.check_cfg (package='lilv-0', uselib_store='LILV', 
                    args=['--libs', '--cflags'], mandatory=True)
    conf.check_cfg (package='suil-0', uselib_store='SUIL', 
                    args=['--libs', '--cflags'], mandatory=True)
    conf.check_cfg (package='gtk+-2.0', uselib_store='GTK',
                    args='--cflags --libs', mandatory=False)

    conf.define('JUCE_MODULE_AVAILABLE_jlv2_host', True)
    conf.write_config_header ('jlv2/config.h', 'JLV2_MODULES_CONFIG_H')
    
    conf.load ('juce')
    conf.check_cxx_version ('c++14', True)
    conf.env.append_unique ('CFLAGS', ['-fvisibility=hidden'])
    conf.env.append_unique ('CXXFLAGS', ['-fvisibility=hidden'])

    print
    juce.display_header ("JLV2")
    juce.display_msg (conf, 'Version',  VERSION)
    juce.display_msg (conf, 'Debug',    conf.env.DEBUG)

    if juce.is_mac():
        print
        juce.display_header ('Mac Options')
        juce.display_msg (conf, 'OSX Arch', conf.env.ARCH)
        juce.display_msg (conf, 'OSX Min Version', conf.options.mac_version_min if len(conf.options.mac_version_min) else 'default')
        juce.display_msg (conf, 'OSX SDK', conf.options.mac_sdk if len(conf.options.mac_sdk) else 'default')
    
    print
    juce.display_header ('Compiler')
    juce.display_msg (conf, 'CFLAGS',   conf.env.CFLAGS)
    juce.display_msg (conf, 'CXXFLAGS', conf.env.CXXFLAGS)
    juce.display_msg (conf, 'LDFLAGS',  conf.env.LINKFLAGS)

def library_slug (bld):
    return 'jlv2_debug-0' if bld.env.DEBUG else 'jlv2-0'

def get_include_path (bld, subpath=''):
    ip = '%s/jlv2-%s' % (bld.env.INCLUDEDIR, '0')
    ip = os.path.join (ip, subpath) if len(subpath) > 0 else ip
    return ip

def install_misc_header (bld, header, subpath=''):
    destination = get_include_path (bld, subpath)
    bld.install_files (destination, header)

def maybe_install_headers (bld):
    for header in [ 'build/jlv2/jlv2.h', 'build/jlv2/config.h', 'build/jlv2/version.h' ]:
        install_misc_header (bld, header, 'jlv2')
    bld.install_files (get_include_path (bld), 
                       bld.path.ant_glob ("modules/**/*.*"),
                       relative_trick=True, 
                       cwd=bld.path.find_dir ('modules'))
    
def build (bld):
    bld (
        features = 'subst',
        source = [ 'jlv2.h.in' ],
        target = 'jlv2/jlv2.h',
        install_path = None,
        name = 'JLV2_HEADER'
    )
    
    bld.add_group()
    
    library = bld (
        features    = 'cxx cxxshlib',
        source      = [ 'src/include_jlv2_host.cpp' ],
        includes    = [ 'build', 'modules' ],
        name        = 'JLV2',
        target      = 'lib/%s' % library_slug (bld),
        use         = [ 'JLV2_HEADER', 'JUCE_AUDIO_PROCESSORS', 
                        'JUCE_DATA_STRUCTURES', 'JUCE_GUI_EXTRA',
                        'LILV', 'SUIL', 'GTK' ],
        vnum        = VERSION
    )

    pcobj = bld (
        features      = 'subst',
        source        = 'jlv2.pc.in',
        target        = '%s.pc' % library_slug (bld),
        install_path  = bld.env.LIBDIR + '/pkgconfig',
        env           = bld.env.derive(),
        MAJOR_VERSION = '0',
        PREFIX        = bld.env.PREFIX,
        INCLUDEDIR    = bld.env.INCLUDEDIR,
        LIBDIR        = bld.env.LIBDIR,
        CFLAGSS       = [],
        DEPLIBS       = '-l%s' % library_slug (bld),
        REQUIRED      = '',
        VERSION       = VERSION
    )

    pcobj.env.CXXFLAGS = pcobj.env.CFLAGS = [] #
    pcobj.REQUIRED += 'juce_audio_processors_debug-5 ' if bld.env.DEBUG else 'juce_audio_processors-5 '
    pcobj.REQUIRED += 'juce_data_structures_debug-5 ' if bld.env.DEBUG else 'juce_data_structures-5 '
    if bld.env.HAVE_SUIL: pcobj.REQUIRED += 'suil-0 '
    if bld.env.HAVE_LILV: pcobj.REQUIRED += 'lilv-0 '
    
    lv2show = bld.program (
        source          = [ 'tools/lv2show.cpp' ],
        includes        = [ 'modules' ],
        target          = 'bin/lv2show',
        use             = [ 'JLV2', 'JUCE_AUDIO_UTILS', 'JUCE_AUDIO_DEVICES' ],
        install_path    = None
    )

    maybe_install_headers (bld)

=== libs/kv/wscript ===
#!/usr/bin/evn python
# encoding: utf-8
# Copyright (C) 2019 Michael Fisher <mfisher@kushview.net>

''' This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public Licence as published by
the Free Software Foundation, either version 2 of the Licence, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
file COPYING for more details. '''

import sys, os, platform
from subprocess import call
from os.path import expanduser

sys.path.insert (0, "tools/waf")
import juce

KV_VERSION = '0.1.0'
KV_MAJOR_VERSION = KV_VERSION[0]
KV_MINOR_VERSION = KV_VERSION[2]
KV_MICRO_VERSION = KV_VERSION[4]
KV_EXTRA_VERSION = ''

APPNAME = 'libkv'
VERSION = KV_VERSION

top = '.'
out = 'build'

juce_modules = '''
    juce_analytics
    juce_audio_basics
    juce_audio_devices
    juce_audio_formats
    juce_audio_processors
    juce_audio_utils
    juce_blocks_basics
    juce_box2d
    juce_core
    juce_cryptography
    juce_data_structures
    juce_events
    juce_opengl
    juce_osc
    juce_graphics
    juce_gui_basics
    juce_gui_extra
    juce_product_unlocking
    juce_video
'''.split()

experimental_modules = '''
    kv_ffmpeg
    kv_video
    kv_edd
'''.split()

library_modules = '''
    kv_core
    kv_engines
    kv_gui
    kv_models
'''.split()

all_modules = library_modules + experimental_modules

cpponly_modules = '''
'''.split()

def options (opts):
    opts.load ('compiler_c compiler_cxx juce')
    opts.add_option ('--enable-edd', default=False, action="store_true", dest="edd",
        help="Enable support for Easy Digital Downloads")
    opts.add_option('--no-headers', default=True, action="store_false", \
        dest="install_headers", help="Don't install headers")

def silence_warnings (conf):
    # TODO: update LV2 module to use latest LV2 / LILV / SUIL
    conf.env.append_unique ('CXXFLAGS', ['-Wno-deprecated-declarations'])

def configure (conf):
    conf.load ('compiler_c compiler_cxx')
    silence_warnings (conf)

    conf.env.DATADIR    = conf.env.PREFIX + '/share'
    conf.env.LIBDIR     = conf.env.PREFIX + '/lib'
    conf.env.BINDIR     = conf.env.PREFIX + '/bin'
    conf.env.INCLUDEDIR = conf.env.PREFIX + '/include'

    conf.env.HEADERS    = conf.options.install_headers
    conf.env.DEBUG      = conf.options.debug

    # Write out the version header
    conf.define ("KV_VERSION", KV_VERSION)
    conf.define ("KV_MAJOR_VERSION", KV_MAJOR_VERSION)
    conf.define ("KV_MINOR_VERSION", KV_MINOR_VERSION)
    conf.define ("KV_MICRO_VERSION", KV_MICRO_VERSION)
    conf.define ("KV_EXTRA_VERSION", KV_EXTRA_VERSION)
    conf.write_config_header ('kv/version.h', 'KV_VERSION_H')

    conf.check_cfg (package='juce_debug-6' if conf.options.debug else 'juce-6', 
                    uselib_store='JUCE', args=['--libs', '--cflags'], mandatory=False)
    
    # for jmod in juce_modules:
    #     pkgname = '%s_debug-5' % jmod if conf.options.debug else '%s-5' % jmod
    #     conf.check_cfg (package=pkgname, uselib_store=jmod.upper(), 
    #                     args=['--libs', '--cflags'], mandatory=False)

    conf.check_cfg (package='lv2',    uselib_store='LV2',  args=['--libs', '--cflags'], mandatory=False)
    conf.check_cfg (package='lilv-0', uselib_store='LILV', args=['--libs', '--cflags'], mandatory=False)
    conf.check_cfg (package='suil-0', uselib_store='SUIL', args=['--libs', '--cflags'], mandatory=False)
    conf.write_config_header ('libkv_config.h')

    conf.env.MODULES = library_modules

    if conf.options.edd:
        conf.env.MODULES.append ('kv_edd')
    
    conf.env.LV2 = False
    conf.define ('KV_LV2_PLUGIN_HOST', 0)
    
    for mod in conf.env.MODULES:
        conf.define('JUCE_MODULE_AVAILABLE_%s' % mod, True)
    
    conf.define ('KV_DOCKING_WINDOWS', True)
    conf.write_config_header ('kv/config.h', 'KV_MODULES_CONFIG_H')
    # conf.define ('JUCE_APP_CONFIG_HEADER', 'kv/config.h')
    
    conf.load ('juce')
    conf.check_cxx_version ('c++17', True)

    print
    juce.display_header ("Modules")
    for m in all_modules:
        juce.display_msg (conf, m, m in conf.env.MODULES)

    if juce.is_mac():
        print
        juce.display_header ('Mac Options')
        juce.display_msg (conf, 'OSX Arch', conf.env.ARCH)
        juce.display_msg (conf, 'OSX Min Version', conf.options.mac_version_min if len(conf.options.mac_version_min) else 'default')
        juce.display_msg (conf, 'OSX SDK', conf.options.mac_sdk if len(conf.options.mac_sdk) else 'default')
    
    print
    juce.display_header ('Compiler')
    juce.display_msg (conf, 'Debug',    conf.env.DEBUG)
    juce.display_msg (conf, 'CFLAGS',   conf.env.CFLAGS)
    juce.display_msg (conf, 'CXXFLAGS', conf.env.CXXFLAGS)
    juce.display_msg (conf, 'LDFLAGS',  conf.env.LINKFLAGS)

def library_slug (bld):
    return 'kv_debug-0' if bld.env.DEBUG else 'kv-0'

def module_slug (bld, mod):
    return '%s_debug-0' % mod if bld.env.DEBUG else '%s-0' % mod

def get_include_path (bld, subpath=''):
    ip = '%s/kv-%s' % (bld.env.INCLUDEDIR, KV_MAJOR_VERSION)
    ip = os.path.join (ip, subpath) if len(subpath) > 0 else ip
    return ip

def install_module_headers (bld, modules):
    for mod in modules:
        bld.install_files (get_include_path (bld), \
                           bld.path.ant_glob ("modules/" + mod + "/**/*.h"), \
                           relative_trick=True, cwd=bld.path.find_dir ('modules'))

def install_misc_header (bld, header, subpath=''):
    destination = get_include_path (bld, subpath)
    bld.install_files (destination, header)

def maybe_install_headers (bld):
    if not bld.env.HEADERS:
        return
    
    install_module_headers (bld, all_modules)
    for header in [ 'kv/kv.h', 'build/kv/config.h', 'build/kv/version.h' ]:
        install_misc_header (bld, header, 'kv')
    for module in all_modules:
        install_misc_header (bld, 'build/kv/%s.h' % module.replace ('kv_', ''), 'kv')

def build_lv2_meta (bld):
    env = bld.env.derive()
    bundle = 'plugins/%s.lv2' % 'kv'
    instdir = os.path.join (expanduser('~'), 'Library/Audio/Plug-Ins/LV2/%s.lv2' % 'kv')
    manifest = bld (
        features    = 'subst',
        source      = '%s/manifest.ttl.in' % bundle,
        target      = 'lib/lv2/%s.lv2/manifest.ttl' % 'kv',
        install_path = instdir
    )

def build_plugin (bld, plugin):
    return
    env = bld.env.derive()
    env.cxxshlib_PATTERN = env.plugin_PATTERN
    bundle = 'plugins/%s.lv2' % plugin
    instdir = os.path.join (expanduser('~'), 'Library/Audio/Plug-Ins/LV2/%s.lv2' % plugin)

    library = bld.shlib (
        source          = bld.path.ant_glob ('%s/*.cpp' % bundle),
        includes        = [ bundle ],
        use             = [ ],
        cxxflags        = [ '-Wno-deprecated-declarations' ],
        name            = plugin,
        target          = 'lib/lv2/%s.lv2/%s' % (plugin, plugin),
        env             = env,
        install_path    = instdir
    )

    manifest = bld (
        features    = 'subst',
        source      = '%s/manifest.ttl.in' % bundle,
        target      = 'lib/lv2/%s.lv2/manifest.ttl' % plugin,
        LIB_EXT     = env.plugin_EXT,
        install_path = instdir
    )

    details = bld (
        features    = 'subst',
        source      = '%s/%s.ttl' % (bundle, plugin),
        target      = 'lib/lv2/%s.lv2/%s.ttl' % (plugin, plugin),
        LIB_EXT     = env.plugin_EXT,
        install_path  = instdir
    )

    return library

def generate_code (bld):
    tasks = []
    for mod in all_modules:
        tasks.append (bld (
            features     = 'subst',
            source       = 'module_header.h.in',
            target       = 'kv/%s.h' % mod.replace ('kv_', ''),
            name         = mod + "_h",
            install_path = None,
            MODULE       = mod
        ))

        tasks.append (bld (
            features     = 'subst',
            source       = 'module_code.cpp.in',
            target       = 'code/include_%s.cpp' % mod,
            name         = mod + "_cpp",
            install_path = None,
            MODULE       = mod
        ))

        if not mod in cpponly_modules:
            tasks.append (bld (
                features     = 'subst',
                source       = 'module_code.mm.in',
                target       = 'code/include_%s.mm' % mod,
                name         = mod + "_mm",
                install_path = None,
                MODULE       = mod
            ))
    bld.add_group()
    return tasks

def build_single (bld):
    library_source = []
    for mod in bld.env.MODULES:
        library_source.append ('build/code/include_%s.cpp' % mod)
    
    library = bld (
        features    = 'cxx cxxshlib',
        source      = library_source,
        includes    = [ 'build', 'modules' ],
        name        = 'KV',
        cxxflags    = [],
        target      = 'lib/%s' % library_slug (bld),
        use         = [ 'JUCE', 'LILV', 'SUIL' ],
        vnum        = VERSION
    )

    pcobj = bld (
        features      = 'subst',
        source        = 'kv.pc.in',
        target        = '%s.pc' % library_slug (bld),
        install_path  = bld.env.LIBDIR + '/pkgconfig',
        MAJOR_VERSION = KV_MAJOR_VERSION,
        PREFIX        = bld.env.PREFIX,
        INCLUDEDIR    = bld.env.INCLUDEDIR,
        LIBDIR        = bld.env.LIBDIR,
        CFLAGSS       = '',
        DEPLIBS       = '-l%s' % library_slug (bld),
        REQUIRED      = 'juce_debug-5' if bld.env.DEBUG else 'juce-5',
        VERSION       = KV_VERSION
    )

    if bld.env.HAVE_SUIL: pcobj.REQUIRED += ' suil-0'
    if bld.env.HAVE_LILV: pcobj.REQUIRED += ' lilv-0'

def build_modules (bld):
    subst_env = bld.env.derive()
    subst_env.CFLAGS = []

    for m in bld.env.MODULES:
        module = juce.ModuleInfo ('modules/%s/%s.h' % (m, m))
        slug = module_slug (bld, m)
        module_libname = '%s' % (module_slug (bld, m))
        ext = 'cpp'

        library = bld (
            features    = 'cxxshlib cxx',
            includes    = [ '.', 'modules' ],
            source      = [ 'build/code/include_%s.%s' % (m, ext) ],
            target      = 'local/lib/%s' % module_libname,
            name        = m.upper(),
            use         = [u.upper() for u in module.dependencies()],
            vnum        = '0.1.0'
        )

        # Pkg Config Files
        pcobj = bld (
            features        = 'subst',
            source          = 'kv_module.pc.in',
            target          = slug + '.pc',
            install_path    = bld.env.LIBDIR + '/pkgconfig',
            env             = subst_env,
            MAJOR_VERSION   = '0',
            PREFIX          = bld.env.PREFIX,
            INCLUDEDIR      = bld.env.INCLUDEDIR,
            LIBDIR          = bld.env.LIBDIR,
            CFLAGS          = '',
            DEPLIBS         = '-l%s' % module_libname,
            REQUIRED        = ' '.join (module.requiredPackages (bool (bld.env.DEBUG))),
            NAME            = module.name(),
            DESCRIPTION     = module.description(),
            VERSION         = module.version()
        )
        
        if m == 'kv_lv2':
            if bld.env.HAVE_SUIL:
                library.use.append ('SUIL')
                pcobj.REQUIRED += ' suil-0'
            if bld.env.HAVE_LILV: 
                library.use.append ('LILV')
                pcobj.REQUIRED += ' lilv-0'

        if juce.is_mac():
            library.use += module.osxFrameworks()
            for framework in module.osxFrameworks (False):
                pcobj.DEPLIBS += ' -framework %s' % framework
    
    jpcobj = bld (
        features        = 'subst',
        source          = 'kv.pc.in',
        target          = library_slug (bld) + '.pc',

=== libs/lua-kv/wscript ===

import os, re, sys
from subprocess import call
from waflib.Build import BuildContext

APPNAME = 'lua-kv'
VERSION = '0.0.1'

def options (opt):
    opt.load ('compiler_c compiler_cxx')
    opt.add_option ('--debug', default=False, action="store_true", dest="debug", \
        help="Compile debuggable binaries [ Default: False ]")
    opt.add_option ('--test', default=False, action='store_true', dest='test', \
        help="Build the test suite [ Default: False ]")
    opt.add_option ('--with-juce', default='', dest='juce', type='string', 
        help='Path to JUCE')

def configure (conf):
    conf.load ('compiler_c compiler_cxx')
    conf.find_program ('ldoc', uselib_store="LDOC", mandatory=False)

    if conf.options.debug:
        conf.define ("DEBUG", 1)
        conf.define ("_DEBUG", 1)
        conf.env.append_unique ('CXXFLAGS', ['-g', '-ggdb', '-O0'])
        conf.env.append_unique ('CFLAGS', ['-g', '-ggdb', '-O0'])
    else:
        conf.define ("NDEBUG", 1)
        conf.env.append_unique ('CXXFLAGS', ['-Os'])
        conf.env.append_unique ('CFLAGS', ['-Os'])
    conf.env.append_unique ('CXXFLAGS', ['-std=c++17'])
    conf.env.append_unique ('CPPFLAGS', ['-DLKV_MODULE'])
    
    if 'darwin' in sys.platform:
        osARCHS = os.getenv ('ARCHS', '')
        if isinstance(osARCHS, str) and len(osARCHS) > 0:
            conf.env.ARCH = osARCHS.split()
        else:
            conf.env.ARCH = []
        
    conf.check_cfg (package='lua', msg='Checking for lua header',  uselib_store='LUA',    args=['--cflags'], mandatory=True)
    conf.check_cfg (package='lua', msg='Checking for lua library', uselib_store='LUALIB', args=['--libs'],   mandatory=True)

    if 'linux' in sys.platform:
        conf.check_cfg (package='freetype2', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='x11', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='xext', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='xrandr', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='xcomposite', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='xinerama', args='--cflags --libs', mandatory=True)
        conf.check_cfg (package='xcursor', args='--cflags --libs', mandatory=True)
        conf.check(header_name='curl/curl.h', uselib_store='CURL', mandatory=True)
        conf.check(lib='curl', uselib_store='CURL', mandatory=True)
    
    jucepath = conf.options.juce
    if len(jucepath) <= 0:
        jucepath = os.path.join (os.path.expanduser("~"), 'SDKs/JUCE')
    conf.env.JUCE_MODULE_PATH = os.path.join (jucepath, 'modules')
    if not os.path.exists (os.path.join (conf.env.JUCE_MODULE_PATH, 'juce_core/juce_core.h')):
        conf.fatal ("Could not find JUCE modules in %s" % conf.env.JUCE_MODULE_PATH)
    
    conf.env.LUA_VERSION = '5.4'
    conf.env.TEST = bool (conf.options.test)   

    if conf.env.SOL:
        ## Sol3 Safety options
        # https://sol2.readthedocs.io/en/latest/safety.html
        conf.define ('SOL_SAFE_USERTYPE', 1)

def module_env (bld):
    env = bld.env.derive()
    if sys.platform == 'windows':
        env.cshlib_PATTERN = env.cxxshlib_PATTERN = '%s.dll'
    else:
        env.cshlib_PATTERN = env.cxxshlib_PATTERN = '%s.so'
        env.macbundle_PATTERN = '%s.so'
    return env

def setup_module (mod):
    if 'linux' in sys.platform or 'darwin' in sys.platform:
        mod.env.append_unique ('LINKFLAGS', [ '-fvisibility=hidden', '-fPIC'])
        mod.env.append_unique ('CFLAGS',    [ '-fvisibility=hidden', '-fPIC'])
        mod.env.append_unique ('CXXFLAGS',  [ '-fvisibility=hidden', '-fPIC'])
    elif sys.platform == 'windows':
        pass
    
    if 'linux' in sys.platform:
        mod.use += [ 'CURL', 'FREETYPE2', 'X11', 'XEXT', 'XRANDR', 'XCOMPOSITE', 'XINERAMA', 'XCURSOR' ]
    elif 'darwin' in sys.platform:
        mod.mac_bundle = True
        mod.env.FRAMEWORK_ACCELERATE     = 'Accelerate'
        mod.env.FRAMEWORK_AUDIO_TOOLBOX  = 'AudioToolbox'
        mod.env.FRAMEWORK_AUDIO_UNIT     = 'AudioUnit'
        mod.env.FRAMEWORK_CORE_AUDIO     = 'CoreAudio'
        mod.env.FRAMEWORK_CORE_AUDIO_KIT = 'CoreAudioKit'
        mod.env.FRAMEWORK_CORE_MIDI      = 'CoreMIDI'
        mod.env.FRAMEWORK_COCOA          = 'Cocoa'
        mod.env.FRAMEWORK_CARBON         = 'Carbon'
        mod.env.FRAMEWORK_DISC_RECORDING = 'DiscRecording'
        mod.env.FRAMEWORK_FOUNDATION     = 'Foundation'
        mod.env.FRAMEWORK_IO_KIT         = 'IOKit'
        mod.env.FRAMEWORK_OPEN_GL        = 'OpenGL'
        mod.env.FRAMEWORK_QT_KIT         = 'QTKit'
        mod.env.FRAMEWORK_QuickTime      = 'QuickTime'
        mod.env.FRAMEWORK_QUARTZ_CORE    = 'QuartzCore'
        mod.env.FRAMEWORK_WEB_KIT        = 'WebKit'
        mod.env.FRAMEWORK_PYTHON         = 'Python'
        mod.use += [ 'COCOA', 'FOUNDATION', 'IO_KIT' ]

    return mod

def juce_module_code (path, module):
    extension = 'cpp'
    if 'darwin' in sys.platform:
        extension = 'mm'

    cpp_only = [ 'juce_analytics', 'juce_osc', 'jlv2_host' ]
    extension = 'cpp' if module in cpp_only else extension
    return os.path.join (path, 'include_%s.%s' % (module, extension))

def build_cmodule (bld):
    mod = bld (
        features    = 'cxx cxxshlib',
        source      =  bld.path.ant_glob ("src/kv/**/*.c") +
                       bld.path.ant_glob ("src/kv/**/*.cpp") + [
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_audio_basics'),
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_core'),
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_data_structures'),
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_events'),
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_graphics'),
                       juce_module_code ('jucer/lua-kv/JuceLibraryCode', 'juce_gui_basics')
                       ],
        includes    = [ 'include', 'src', 'jucer/lua-kv/JuceLibraryCode',
                        bld.env.JUCE_MODULE_PATH ],
        name        = 'KVCMODULE',
        target      = 'lib/lua/kv',
        env         = module_env (bld),
        use         = [ 'LUA' ],
        cflags      = [],
        cxxflags    = [],
        linkflags   = [],
        install_path = '%s/lib/lua/%s/kv' % (bld.env.PREFIX, bld.env.LUA_VERSION)
    )
    return setup_module (mod)

def build_lua_docs (bld):
    if bool(bld.env.LDOC):
        call ([bld.env.LDOC[0], '-f', 'markdown', '.' ])

def docs (ctx):
    ctx.add_pre_fun (build_lua_docs)

def build (bld):
    build_cmodule (bld)
    bld.add_group()
    bld.install_files ('%s/share/lua/5.4/kv' % bld.env.PREFIX,
                       bld.path.ant_glob ('src/kv/*.lua'))

    if False: # bld.env.TEST:
        tests = bld.program (
            source       = [ 'tests/test.c' ],
            includes     = [ '.', 'src' ],
            name         = 'test',
            target       = 'test',
            use          = [ 'LUA', 'LUA_LIB' ],
            linkflags    = [],
            install_path = None
        )

        if 'linux' in sys.platform:
            tests.linkflags.append ('-Wl,--no-as-needed')
            tests.linkflags.append ('-lm')
            tests.linkflags.append ('-ldl')

def check (ctx):
    if 0 != call (["lua", "./test/run.lua"]):
        ctx.fatal ("Tests failed")

class DocsBuildContext (BuildContext):
    cmd = 'docs'
    fun = 'docs'

from waflib import TaskGen
@TaskGen.extension ('.mm')
def juce_mm_hook (self, node):
    return self.create_compiled_task ('cxx', node)

from waflib import TaskGen
@TaskGen.extension ('.m')
def juce_m_hook (self, node):
    return self.create_compiled_task ('c', node)

=== libs/lua/Makefile ===
# Makefile for installing Lua
# See doc/readme.html for installation and customization instructions.

# == CHANGE THE SETTINGS BELOW TO SUIT YOUR ENVIRONMENT =======================

# Your platform. See PLATS for possible values.
PLAT= guess

# Where to install. The installation starts in the src and doc directories,
# so take care if INSTALL_TOP is not an absolute path. See the local target.
# You may want to make INSTALL_LMOD and INSTALL_CMOD consistent with
# LUA_ROOT, LUA_LDIR, and LUA_CDIR in luaconf.h.
INSTALL_TOP= /usr/local
INSTALL_BIN= $(INSTALL_TOP)/bin
INSTALL_INC= $(INSTALL_TOP)/include
INSTALL_LIB= $(INSTALL_TOP)/lib
INSTALL_MAN= $(INSTALL_TOP)/man/man1
INSTALL_LMOD= $(INSTALL_TOP)/share/lua/$V
INSTALL_CMOD= $(INSTALL_TOP)/lib/lua/$V

# How to install. If your install program does not support "-p", then
# you may have to run ranlib on the installed liblua.a.
INSTALL= install -p
INSTALL_EXEC= $(INSTALL) -m 0755
INSTALL_DATA= $(INSTALL) -m 0644
#
# If you don't have "install" you can use "cp" instead.
# INSTALL= cp -p
# INSTALL_EXEC= $(INSTALL)
# INSTALL_DATA= $(INSTALL)

# Other utilities.
MKDIR= mkdir -p
RM= rm -f

# == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======

# Convenience platforms targets.
PLATS= guess aix bsd c89 freebsd generic linux linux-readline macosx mingw posix solaris

# What to install.
TO_BIN= lua luac
TO_INC= lua.h luaconf.h lualib.h lauxlib.h lua.hpp
TO_LIB= liblua.a
TO_MAN= lua.1 luac.1

# Lua version and release.
V= 5.4
R= $V.1

# Targets start here.
all:	$(PLAT)

$(PLATS) help test clean:
	@cd src && $(MAKE) $@

install: dummy
	cd src && $(MKDIR) $(INSTALL_BIN) $(INSTALL_INC) $(INSTALL_LIB) $(INSTALL_MAN) $(INSTALL_LMOD) $(INSTALL_CMOD)
	cd src && $(INSTALL_EXEC) $(TO_BIN) $(INSTALL_BIN)
	cd src && $(INSTALL_DATA) $(TO_INC) $(INSTALL_INC)
	cd src && $(INSTALL_DATA) $(TO_LIB) $(INSTALL_LIB)
	cd doc && $(INSTALL_DATA) $(TO_MAN) $(INSTALL_MAN)

uninstall:
	cd src && cd $(INSTALL_BIN) && $(RM) $(TO_BIN)
	cd src && cd $(INSTALL_INC) && $(RM) $(TO_INC)
	cd src && cd $(INSTALL_LIB) && $(RM) $(TO_LIB)
	cd doc && cd $(INSTALL_MAN) && $(RM) $(TO_MAN)

local:
	$(MAKE) install INSTALL_TOP=../install

# make may get confused with install/ if it does not support .PHONY.
dummy:

# Echo config parameters.
echo:
	@cd src && $(MAKE) -s echo
	@echo "PLAT= $(PLAT)"
	@echo "V= $V"
	@echo "R= $R"
	@echo "TO_BIN= $(TO_BIN)"
	@echo "TO_INC= $(TO_INC)"
	@echo "TO_LIB= $(TO_LIB)"
	@echo "TO_MAN= $(TO_MAN)"
	@echo "INSTALL_TOP= $(INSTALL_TOP)"
	@echo "INSTALL_BIN= $(INSTALL_BIN)"
	@echo "INSTALL_INC= $(INSTALL_INC)"
	@echo "INSTALL_LIB= $(INSTALL_LIB)"
	@echo "INSTALL_MAN= $(INSTALL_MAN)"
	@echo "INSTALL_LMOD= $(INSTALL_LMOD)"
	@echo "INSTALL_CMOD= $(INSTALL_CMOD)"
	@echo "INSTALL_EXEC= $(INSTALL_EXEC)"
	@echo "INSTALL_DATA= $(INSTALL_DATA)"

# Echo pkg-config data.
pc:
	@echo "version=$R"
	@echo "prefix=$(INSTALL_TOP)"
	@echo "libdir=$(INSTALL_LIB)"
	@echo "includedir=$(INSTALL_INC)"

# Targets that do not create files (not all makes understand .PHONY).
.PHONY: all $(PLATS) help test clean install uninstall local dummy echo pc

# (end of Makefile)

=== libs/lv2/wscript ===
#!/usr/bin/env python
import glob
import os
import re
import shutil
import subprocess
import sys

from waflib.extras import autowaf as autowaf
import waflib.Context as Context
import waflib.Logs as Logs
import waflib.Options as Options
import waflib.Scripting as Scripting
import waflib.Utils as Utils

# Variables for 'waf dist'
APPNAME = 'lv2'
VERSION = '1.14.0'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_c')
    opt.load('lv2')
    autowaf.set_options(opt, False, True)
    opt.add_option('--test', action='store_true', dest='build_tests',
                   help='Build unit tests')
    opt.add_option('--no-coverage', action='store_true', dest='no_coverage',
                   help='Do not use gcov for code coverage')
    opt.add_option('--online-docs', action='store_true', dest='online_docs',
                   help='Build documentation for web hosting')
    opt.add_option('--no-plugins', action='store_true', dest='no_plugins',
                   help='Do not build example plugins')
    opt.add_option('--copy-headers', action='store_true', dest='copy_headers',
                   help='Copy headers instead of linking to bundle')
    opt.recurse('lv2/lv2plug.in/ns/lv2core')

def configure(conf):
    try:
        conf.load('compiler_c')
    except:
        Options.options.build_tests = False
        Options.options.no_plugins = True

    conf.load('lv2')
    autowaf.configure(conf)
    autowaf.set_c99_mode(conf)

    if Options.options.online_docs:
        Options.options.docs = True

    if Options.options.ultra_strict:
        conf.env.append_value('CFLAGS', ['-Wconversion'])

    if Options.platform == 'win32' or not hasattr(os.path, 'relpath'):
        Logs.warn('System does not support linking headers, copying')
        Options.options.copy_headers = True

    conf.env.BUILD_TESTS   = Options.options.build_tests
    conf.env.BUILD_PLUGINS = not Options.options.no_plugins
    conf.env.COPY_HEADERS  = Options.options.copy_headers
    conf.env.ONLINE_DOCS   = Options.options.online_docs

    if conf.env.DOCS or conf.env.ONLINE_DOCS:
        try:
            conf.find_program('asciidoc')
            conf.env.BUILD_BOOK = True
        except:
            Logs.warn('Asciidoc not found, book will not be built')

    # Check for gcov library (for test coverage)
    if (conf.env.BUILD_TESTS
        and not Options.options.no_coverage
        and not conf.is_defined('HAVE_GCOV')):
        conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)

    autowaf.set_recursive()

    conf.recurse('lv2/lv2plug.in/ns/lv2core')

    conf.env.LV2_BUILD = ['lv2/lv2plug.in/ns/lv2core']
    if conf.env.BUILD_PLUGINS:
        for i in conf.path.ant_glob('plugins/*', src=False, dir=True):
            try:
                conf.recurse(i.srcpath())
                conf.env.LV2_BUILD += [i.srcpath()]
            except:
                Logs.warn('Configuration failed, %s will not be built\n' % i)

    autowaf.configure(conf)
    autowaf.display_header('LV2 Configuration')
    autowaf.display_msg(conf, 'Bundle directory', conf.env.LV2DIR)
    autowaf.display_msg(conf, 'Copy (not link) headers', conf.env.COPY_HEADERS)
    autowaf.display_msg(conf, 'Version', VERSION)

def chop_lv2_prefix(s):
    if s.startswith('lv2/lv2plug.in/'):
        return s[len('lv2/lv2plug.in/'):]
    return s

# Rule for calling lv2specgen on a spec bundle
def specgen(task):
    import rdflib
    doap = rdflib.Namespace('http://usefulinc.com/ns/doap#')
    lv2  = rdflib.Namespace('http://lv2plug.in/ns/lv2core#')
    owl  = rdflib.Namespace('http://www.w3.org/2002/07/owl#')
    rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')

    sys.path.append('./lv2specgen')
    import lv2specgen

    spec   = task.inputs[0]
    path   = os.path.dirname(spec.srcpath())
    outdir = os.path.abspath(os.path.join(out, chop_lv2_prefix(path)))

    bundle = str(outdir)
    b = os.path.basename(outdir)

    if not os.access(spec.abspath(), os.R_OK):
        print('warning: extension %s has no %s.ttl file' % (b, b))
        return

    try:
        model = load_ttl(glob.glob('%s/*.ttl' % bundle))
    except:
        e = sys.exc_info()[1]
        print('error parsing %s: %s' % (bundle, str(e)))
        return

    # Get extension URI
    ext_node = model.value(None, rdf.type, lv2.Specification)
    if not ext_node:
        print('no extension found in %s' % bundle)
        return

    ext = str(ext_node)

    # Get version
    minor = 0
    micro = 0
    try:
        minor = int(model.value(ext_node, lv2.minorVersion, None))
        micro = int(model.value(ext_node, lv2.microVersion, None))
    except:
        e = sys.exc_info()[1]
        print('warning: %s: failed to find version for %s' % (bundle, ext))

    # Get date
    date = None
    for r in model.triples([ext_node, doap.release, None]):
        revision = model.value(r[2], doap.revision, None)
        if str(revision) == ('%d.%d' % (minor, micro)):
            date = model.value(r[2], doap.created, None)
            break

    # Verify that this date is the latest
    for r in model.triples([ext_node, doap.release, None]):
        this_date = model.value(r[2], doap.created, None)
        if this_date > date:
            print('warning: %s revision %d.%d (%s) is not the latest release' % (
                ext_node, minor, micro, date))
            break

    # Get name and short description
    name      = model.value(ext_node, doap.name, None)
    shortdesc = model.value(ext_node, doap.shortdesc, None)

    # Chop 'LV2' prefix from name for cleaner index
    if name.startswith('LV2 '):
        name = name[4:]

    # Root link
    ctx = task.generator.bld
    root_path = path[0:path.find('ns/') + 3]
    root_link = os.path.relpath(root_path, path)
    if not task.generator.bld.env.ONLINE_DOCS:
        root_link = os.path.join(root_link, 'index.html')

    SPECGENDIR = 'lv2specgen'
    STYLEPATH  = 'build/aux/style.css'
    TAGFILE    = 'build/doc/tags'

    specdoc = lv2specgen.specgen(
        spec.abspath(),
        SPECGENDIR,
        os.path.relpath(STYLEPATH, bundle),
        os.path.relpath('build/doc/html', bundle),
        TAGFILE,
        { 'list_email': 'devel@lists.lv2plug.in',
          'list_page': 'http://lists.lv2plug.in/listinfo.cgi/devel-lv2plug.in' },
        instances=True,
        root_link=root_link)

    lv2specgen.save(task.outputs[0].abspath(), specdoc)

    # Specification (comment is to act as a sort key)
    target = path[len('lv2/lv2plug.in/ns/'):]
    if not task.env.ONLINE_DOCS:
        target += '/%s.html' % b
    row = '<tr><!-- %s --><td><a rel="rdfs:seeAlso" href="%s">%s</a></td>' % (
        b, target, name)

    # API
    row += '<td><a rel="rdfs:seeAlso" href="../doc/html/group__%s.html">%s</a></td>' % (
        b, b)

    # Description
    if shortdesc:
        row += '<td>' + str(shortdesc) + '</td>'
    else:
        row += '<td></td>'

    # Version
    version_str = '%s.%s' % (minor, micro)
    if minor == 0 or (micro % 2 != 0):
        row += '<td><span style="color: red">' + version_str + '</span></td>'
    else:
        row += '<td>' + version_str + '</td>'

    # Status
    deprecated = model.value(ext_node, owl.deprecated, None)
    if minor == 0:
        row += '<td><span class="error">Experimental</span></td>'
    elif deprecated and str(deprecated[2]) != "false":
        row += '<td><span class="warning">Deprecated</span></td>'
    elif micro % 2 == 0:
        row += '<td><span class="success">Stable</span></td>'

    row += '</tr>'

    index = open(os.path.join('build', 'index_rows', b), 'w')
    index.write(row)
    index.close()

def subst_file(template, output, dict):
    i = open(template, 'r')
    o = open(output, 'w')
    for line in i:
        for key in dict:
            line = line.replace(key, dict[key])
        o.write(line)
    i.close()
    o.close()

def specdirs(path):
    return ([path.find_node('lv2/lv2plug.in/ns/lv2core')] +
            path.ant_glob('plugins/*', dir=True) +
            path.ant_glob('lv2/lv2plug.in/ns/ext/*', dir=True) +
            path.ant_glob('lv2/lv2plug.in/ns/extensions/*', dir=True))

def ttl_files(path, specdir):
    def abspath(node):
        return node.abspath()

    return map(abspath,
               path.ant_glob(specdir.path_from(path) + '/*.ttl'))

def load_ttl(files):
    import rdflib
    model = rdflib.ConjunctiveGraph()
    for f in files:
        model.parse(f, format='n3')
    return model

# Task to build extension index
def build_index(task):
    sys.path.append('./lv2specgen')
    import rdflib
    import lv2specgen

    doap = rdflib.Namespace('http://usefulinc.com/ns/doap#')
    lv2  = rdflib.Namespace('http://lv2plug.in/ns/lv2core#')
    rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')

    model = load_ttl(['lv2/lv2plug.in/ns/meta/meta.ttl'])

    # Get date for this version, and list of all LV2 distributions
    proj  = rdflib.URIRef('http://lv2plug.in/ns/lv2')
    date  = None
    dists = []
    for r in model.triples([proj, doap.release, None]):
        revision = model.value(r[2], doap.revision, None)
        created  = model.value(r[2], doap.created, None)
        if str(revision) == VERSION:
            date = created

        dist = model.value(r[2], doap['file-release'], None)
        if dist and created:
            dists += [(created, dist)]
        else:
            print('warning: %s has no file release\n' % proj)

    # Get history for this LV2 release
    entries = lv2specgen.specHistoryEntries(model, proj, {})

    # Add entries for every spec that has the same distribution
    ctx     = task.generator.bld
    subdirs = specdirs(ctx.path)
    for specdir in subdirs:
        m    = load_ttl(ttl_files(ctx.path, specdir))
        name = os.path.basename(specdir.abspath())
        spec = m.value(None, rdf.type, lv2.Specification)
        if spec:
            for dist in dists:
                release = m.value(None, doap['file-release'], dist[1])
                if release:
                    entries[dist] += lv2specgen.releaseChangeset(m, release, str(name))

    # Generate history for all post-unification LV2 distributions
    history = lv2specgen.specHistoryMarkup(entries)

    rows = []
    for f in task.inputs:
        if not f.abspath().endswith('index.html.in'):
            rowfile = open(f.abspath(), 'r')
            rows += rowfile.readlines()
            rowfile.close()

    if date is None:
        import datetime
        date = datetime.datetime.now().isoformat()

    subst_file(task.inputs[0].abspath(), task.outputs[0].abspath(),
               { '@ROWS@': ''.join(rows),
                 '@LV2_VERSION@': VERSION,
                 '@DATE@' : date,
                 '@HISTORY@' : history})

# Task for making a link in the build directory to a source file
def link(task):
    if not task.env.COPY_HEADERS and hasattr(os, 'symlink'):
        func = os.symlink
    else:
        func = shutil.copy  # Symlinks unavailable, make a copy

    try:
        os.remove(task.outputs[0].abspath())  # Remove old target
    except:
        pass  # No old target, whatever

    func(task.inputs[0].abspath(), task.outputs[0].abspath())

def build_ext(bld, path):
    name        = os.path.basename(path)
    bundle_dir  = os.path.join(bld.env.LV2DIR, name + '.lv2')
    include_dir = os.path.join(bld.env.INCLUDEDIR, path)

    # Copy headers to URI-style include paths in build directory
    for i in bld.path.ant_glob(path + '/*.h'):
        bld(rule   = link,
            source = i,
            target = bld.path.get_bld().make_node('%s/%s' % (path, i)))

    # Build test program if applicable
    if bld.env.BUILD_TESTS and bld.path.find_node(path + '/%s-test.c' % name):
        test_lib       = []
        test_cflags    = ['']
        test_linkflags = ['']
        if bld.is_defined('HAVE_GCOV'):
            test_lib       += ['gcov', 'rt']

=== libs/JUCE/examples/CMakeLists.txt ===
# ==============================================================================
#
#  This file is part of the JUCE library.
#  Copyright (c) 2020 - Raw Material Software Limited
#
#  JUCE is an open source library subject to commercial or open-source
#  licensing.
#
#  By using JUCE, you agree to the terms of both the JUCE 6 End-User License
#  Agreement and JUCE Privacy Policy (both effective as of the 16th June 2020).
#
#  End User License Agreement: www.juce.com/juce-6-licence
#  Privacy Policy: www.juce.com/juce-privacy-policy
#
#  Or: You may also use this code under the terms of the GPL v3 (see
#  www.gnu.org/licenses).
#
#  JUCE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY, AND ALL WARRANTIES, WHETHER
#  EXPRESSED OR IMPLIED, INCLUDING MERCHANTABILITY AND FITNESS FOR PURPOSE, ARE
#  DISCLAIMED.
#
# ==============================================================================

set(CMAKE_FOLDER examples)

add_subdirectory(CMake)
add_subdirectory(DemoRunner)

function(_juce_add_pips)
    file(GLOB headers
        CONFIGURE_DEPENDS LIST_DIRECTORIES false
        "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

    if((CMAKE_SYSTEM_NAME STREQUAL "Linux") OR (CMAKE_SYSTEM_NAME MATCHES ".*BSD"))
        list(REMOVE_ITEM headers
            "${CMAKE_CURRENT_SOURCE_DIR}/CameraDemo.h"
            "${CMAKE_CURRENT_SOURCE_DIR}/PushNotificationsDemo.h"
            "${CMAKE_CURRENT_SOURCE_DIR}/VideoDemo.h")
    elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
        list(REMOVE_ITEM headers
            "${CMAKE_CURRENT_SOURCE_DIR}/PushNotificationsDemo.h")
    endif()

    foreach(header IN ITEMS ${headers})
        juce_add_pip(${header} added_target)
        target_link_libraries(${added_target} PUBLIC
            juce::juce_recommended_config_flags
            juce::juce_recommended_lto_flags
            juce::juce_recommended_warning_flags)
    endforeach()
endfunction()

add_subdirectory(Audio)
add_subdirectory(BLOCKS)
add_subdirectory(DSP)
add_subdirectory(GUI)
add_subdirectory(Plugins)
add_subdirectory(Utilities)

=== libs/JUCE/modules/CMakeLists.txt ===
# ==============================================================================
#
#  This file is part of the JUCE library.
#  Copyright (c) 2020 - Raw Material Software Limited
#
#  JUCE is an open source library subject to commercial or open-source
#  licensing.
#
#  By using JUCE, you agree to the terms of both the JUCE 6 End-User License
#  Agreement and JUCE Privacy Policy (both effective as of the 16th June 2020).
#
#  End User License Agreement: www.juce.com/juce-6-licence
#  Privacy Policy: www.juce.com/juce-privacy-policy
#
#  Or: You may also use this code under the terms of the GPL v3 (see
#  www.gnu.org/licenses).
#
#  JUCE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY, AND ALL WARRANTIES, WHETHER
#  EXPRESSED OR IMPLIED, INCLUDING MERCHANTABILITY AND FITNESS FOR PURPOSE, ARE
#  DISCLAIMED.
#
# ==============================================================================

juce_add_modules(
    INSTALL_PATH "include/JUCE-${JUCE_VERSION}/modules"
    ALIAS_NAMESPACE juce
    juce_analytics
    juce_audio_basics
    juce_audio_devices
    juce_audio_formats
    juce_audio_plugin_client
    juce_audio_processors
    juce_audio_utils
    juce_blocks_basics
    juce_box2d
    juce_core
    juce_cryptography
    juce_data_structures
    juce_dsp
    juce_events
    juce_graphics
    juce_gui_basics
    juce_gui_extra
    juce_opengl
    juce_osc
    juce_product_unlocking
    juce_video)

=== libs/JUCE/docs/doxygen/Makefile ===
SHELL := /bin/bash

SOURCE_FILES := $(shell find ../../modules -type f -name "juce_*.h" -or -name "juce_*.dox" | sed 's/ /\\ /g')

.PHONEY: clean

doc/index.html: build/juce_modules.dox Doxyfile
	doxygen

build/juce_modules.dox: process_source_files.py $(SOURCE_FILES)
	python $< ../../modules build

clean:
	rm -rf build doc

=== libs/JUCE/examples/CMake/CMakeLists.txt ===
# ==============================================================================
#
#  This file is part of the JUCE library.
#  Copyright (c) 2020 - Raw Material Software Limited
#
#  JUCE is an open source library subject to commercial or open-source
#  licensing.
#
#  By using JUCE, you agree to the terms of both the JUCE 6 End-User License
#  Agreement and JUCE Privacy Policy (both effective as of the 16th June 2020).
#
#  End User License Agreement: www.juce.com/juce-6-licence
#  Privacy Policy: www.juce.com/juce-privacy-policy
#
#  Or: You may also use this code under the terms of the GPL v3 (see
#  www.gnu.org/licenses).
#
#  JUCE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY, AND ALL WARRANTIES, WHETHER
#  EXPRESSED OR IMPLIED, INCLUDING MERCHANTABILITY AND FITNESS FOR PURPOSE, ARE
#  DISCLAIMED.
#
# ==============================================================================

add_subdirectory(AudioPlugin)
add_subdirectory(ConsoleApp)
add_subdirectory(GuiApp)

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>

pkgname=element
_commit=70135d89febc8bd3a46ad874b8338350ec5e9c49  # refs/tags/0.46.6
pkgver=0.46.6
pkgrel=2
pkgdesc="A modular LV2/VST3 audio plugin host"
arch=(x86_64)
url="https://github.com/kushview/element"
license=(GPL3)
groups=(pro-audio)
depends=(gcc-libs glibc hicolor-icon-theme libx11 libxext)
makedepends=(alsa-lib boost curl freetype2 git gtk3 imagemagick jack juce
ladspa ldoc libxcomposite libxcursor libxinerama lilv lua lv2 pango readline
serd sord sratom suil waf xorg-xrandr)
checkdepends=(xorg-server-xvfb)
optdepends=('lua: for LUA scripting')
provides=(ladspa-host lv2-host vst3-host)
source=(
  https://github.com/kushview/element/releases/download/$pkgver/element-$pkgver.tar.gz
  git+https://github.com/kushview/$pkgname#tag=$_commit?signed
  git+https://github.com/kushview/kv-modules
#  git+https://github.com/kushview/JUCE - no longer available
  git+https://github.com/lvtk/jlv2
  git+https://github.com/kushview/lua-kv
)
sha512sums=('aa4344137ffc12bdeca24619aeb5f752499fa83e48dbc2b7821aafc0f13861fa68db47c25986fe707bb751af8ae288901f408708c3268ce4da8bb747d0a07de9'
            '983607476f27a2a34c555cefd490b1815b1a827113de1ef524752bceef6b75e5208ae8c1dd96c179e0a0c0c6ad8c7bf436f035123da02abda8bce606c2096092'
            'SKIP'
            'SKIP'
            'SKIP')
b2sums=('392c1f7899cb68416489e5831dd5e288f9eaed2778b624593fceb7e7126f10c4dc08aeba7e267944e36b07dcbe0ea7dd0db3ed7064d9499253f921350e89e8b8'
        'e2d1a0e3dce088c1b4c3309c9c05ab0f51d455b5764cc04a879fce26c2b694f7b09e3f984ad50602f03fffd76955daf8c53e4769f03e2609bee9fb1f260efb20'
        'SKIP'
        'SKIP'
        'SKIP')
validpgpkeys=('52CB000FABB9DBE345CD478980A5F4BE60360CDE') # Michael Fisher <mfisher@kushview.net>

prepare() {
  cd $pkgname
  git submodule init
  git submodule deinit "libs/JUCE"
  git config submodule.libs/kv.url "$srcdir/kv-modules"
#  git config submodule.libs/JUCE.url "$srcdir/JUCE"
  cp -r "$srcdir"/$pkgname-$pkgver/libs/JUCE libs
  git config submodule.libs/jlv2.url "$srcdir/jlv2"
  git config submodule.libs/lua-kv.url "$srcdir/lua-kv"
  git -c protocol.file.allow=always submodule update

  rm -frv waflib
}

build() {
  export LINKFLAGS="$LDFLAGS"
  CFLAGS+=" -I/usr/share/juce/modules/"

  cd $pkgname
  waf configure \
    --prefix=/usr \
    --enable-docking \
    --juce-path "/usr/share/juce/modules/" \
    --test
  waf build -vv
}

check() {
  cd $pkgname
  LD_LIBRARY_PATH="$PWD/build/lib:$LD_LIBRARY_PATH" xvfb-run waf check \
  || echo "Known issues with LUA related tests: https://github.com/kushview/Element/issues/439"
}

package() {
  depends+=(libasound.so libcurl.so libfreetype.so libjack.so liblilv-0.so
  libsuil-0.so)

  cd $pkgname
  waf install --destdir="$pkgdir"
  install -vDm 644 {AUTHORS,CODE_OF_CONDUCT,CONTRIBUTING,README}.md -t "$pkgdir/usr/share/doc/$pkgname/"
  install -vDm 644 docs/*.md -t "$pkgdir/usr/share/doc/$pkgname/docs"
  install -vDm 644 docs/img/*.png -t "$pkgdir/usr/share/doc/$pkgname/docs/img"
}
